Attribute VB_Name = "modSecureSubclassing"
'secure subclassing experiments.
'by daniel aue, Jan.2004
Option Explicit



Private Declare Sub API_CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" _
   (ByVal lpDestination As Long, ByVal lpSource As Long, ByVal Length As Long)


Private Declare Function SetProp Lib "user32.dll" Alias "SetPropA" (ByVal hwnd As Long, _
   ByVal lpString As String, ByVal hData As Long) As Long

Private Declare Function GetProp Lib "user32.dll" Alias "GetPropA" (ByVal hwnd As Long, _
   ByVal lpString As String) As Long

Private Declare Function RemoveProp Lib "user32.dll" Alias "RemovePropA" (ByVal hwnd As Long, _
   ByVal lpString As String) As Long


Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" _
        (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long


Private Declare Function GlobalAlloc Lib "kernel32.dll" (ByVal wFlags As Long, _
   ByVal dwBytes As Long) As Long

Private Declare Function GlobalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long

Private Const GMEM_FIXED As Long = &H0


Private Const GWL_WNDPROC As Long = -4

Private Const WM_VSCROLL As Long = &H115
Private Const WM_HSCROLL As Long = &H114
Private Const WM_MOUSEMOVE As Long = &H200
Private Const WM_LBUTTONDOWN As Long = &H201
Private Const WM_PAINT As Long = &HF
Private Const WM_KEYDOWN As Long = &H100
Private Const WM_KEYUP As Long = &H101
Private Const WM_DESTROY As Long = &H2
Private Const WM_ENABLE As Long = &HA
Private Const WM_ACTIVATE As Long = &H6
Private Const WM_WINDOWPOSCHANGED As Long = &H47



Private Const MK_LBUTTON As Long = &H1

Dim AppIsRunning As Boolean

Public Function Subclass(hwnd As Long, CallerInstance As Object, Optional Remove As Boolean = False)
   Dim lTemp As Long
   Dim lpNewWinProc As Long


   If Remove = True Then
      
      lTemp = GetProp(hwnd, "Subclass-OldProc")
      If lTemp <> 0 Then
         'restore old Proc
         Call SetWindowLong(hwnd, GWL_WNDPROC, lTemp)
         RemoveProp hwnd, "Subclass-Client"
         RemoveProp hwnd, "Subclass-OldProc"
         lTemp = GetProp(hwnd, "Subclass-AsmHandler")
         RemoveProp hwnd, "Subclass-AsmHandler"
         lTemp = GlobalFree(lTemp)
      End If
   
   ElseIf hwnd <> 0 Then
      
      'is it allready hooked ?
      lTemp = GetProp(hwnd, "Subclass-OldProc")
      If lTemp <> 0 Then
         Err.Raise 1, , "This Window " & Hex(hwnd) & " is allready hooked !"
      End If
      lTemp = ObjPtr(CallerInstance)
      SetProp hwnd, "Subclass-Client", lTemp
      
      'get oldProc Address without changing it:
      lTemp = SetWindowLong(hwnd, GWL_WNDPROC, ByVal 0&)
      SetProp hwnd, "Subclass-OldProc", lTemp
   
      'create asm proc (see end of module for source)
       Static asm(40) As Long
   
       If asm(0) = 0 Then
           asm(0) = &HAEB:       asm(1) = &H12345678:  asm(2) = &H12345678:  asm(3) = &HE8
           asm(4) = &H24048B00:  asm(5) = &HFFFFF105:  asm(6) = &H8B00FEFF:  asm(7) = &HFFEC8BC5
           asm(8) = &H75FF1475:  asm(9) = &HC75FF10:   asm(10) = &H8B0875FF: asm(11) = &H24448BE8
           asm(12) = &HFFF30510: asm(13) = &H8BFFFF:   asm(14) = &H8B50D0FF: asm(15) = &H5042444
           asm(16) = &HFFFFFFF1: asm(17) = &H7C8108FE: asm(18) = &H1141024:  asm(19) = &H18740000
           asm(20) = &H10247C81: asm(21) = &H115:      asm(22) = &H448B0E74: asm(23) = &HF1050424
           asm(24) = &H80FFFFFF: asm(25) = &H34750038: asm(26) = &H17880:    asm(27) = &H40FE2E75
           asm(28) = &H8BC58B01: asm(29) = &H1875FFEC: asm(30) = &HFF1475FF: asm(31) = &H75FF1075
           asm(32) = &H8BE88B0C: asm(33) = &H5142444:  asm(34) = &HFFFFFFF7: asm(35) = &HD0FF008B
           asm(36) = &H424448B:  asm(37) = &HFFFFF105: asm(38) = &H148FEFF:  asm(39) = &H4C48358
           asm(40) = &H10C2
       End If
      
      asm(1) = lTemp 'oldProc Adress
      asm(2) = GetAddressOf(AddressOf NewWndProc)
   
      'reserve memory and clone it
      lpNewWinProc = GlobalAlloc(GMEM_FIXED, (UBound(asm) + 1) * 4)
      API_CopyMemory ByVal lpNewWinProc, VarPtr(asm(0)), (UBound(asm) + 1) * 4
      
      SetProp hwnd, "Subclass-AsmHandler", lpNewWinProc
   
      'install it
      lTemp = SetWindowLong(hwnd, GWL_WNDPROC, lpNewWinProc)

   End If
   AppIsRunning = True
End Function

Private Function GetAddressOf(Address As Long) As Long
   GetAddressOf = Address
End Function



Public Function NewWndProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, _
         ByVal lParam As Long) As Long
   
   Dim oCallerInstance As Object
   Dim lTempClient As Long
   Dim lTempOldProc As Long


   If AppIsRunning = False Then
      'so you've pressed ide-stop somewhere ?
      lTempOldProc = GetProp(hwnd, "Subclass-OldProc")
      If lTempOldProc <> 0 Then
         Call SetWindowLong(hwnd, GWL_WNDPROC, lTempOldProc)
      End If
      RemoveProp hwnd, "Subclass-Client"
      RemoveProp hwnd, "Subclass-OldProc"
      RemoveProp hwnd, "Subclass-AsmHandler"
      Exit Function
   End If
   
   'get client object
   lTempClient = GetProp(hwnd, "Subclass-Client")
   If lTempClient = 0 Then
      Exit Function
   End If
   Set oCallerInstance = GetObjectFromRef(lTempClient)

   Select Case uMsg
   Case WM_DESTROY
      'so you've forgotten to remove the hook before unloading...zzz
      'ok, we'll remove the properties, but we cannot free the memory
      'for the asm code. When the process terminates it's gone anyway.
      lTempOldProc = GetProp(hwnd, "Subclass-OldProc")
      If lTempOldProc <> 0 Then
         Call SetWindowLong(hwnd, GWL_WNDPROC, lTempOldProc)
      End If
      RemoveProp hwnd, "Subclass-Client"
      RemoveProp hwnd, "Subclass-OldProc"
      RemoveProp hwnd, "Subclass-AsmHandler"

   Case WM_HSCROLL
      oCallerInstance.HandleHScrollEvents wParam And &HFFFF&, lParam
   Case WM_VSCROLL
      oCallerInstance.HandleVScrollEvents wParam And &HFFFF&, lParam
   Case WM_MOUSEMOVE
      If (wParam And MK_LBUTTON) = MK_LBUTTON Then
         oCallerInstance.HandleMouseEvents wParam, lParam
      End If
   Case WM_LBUTTONDOWN
      oCallerInstance.HandleMouseEvents wParam, lParam
   Case WM_KEYDOWN
      oCallerInstance.HandleKeyboardEvents wParam, lParam
   Case WM_PAINT
      oCallerInstance.HandlePaintEvent
   Case WM_WINDOWPOSCHANGED
      oCallerInstance.HandleResizeEvent
   End Select

End Function


Public Function GetObjectFromRef(Address As Long) As Object
   Dim lTemp As Long
   Dim oTemp As Object
   API_CopyMemory VarPtr(oTemp), VarPtr(Address), 4
   Set GetObjectFromRef = oTemp
   lTemp = 0
   API_CopyMemory VarPtr(oTemp), VarPtr(lTemp), 4
End Function



'Assembler Source that handles Rekursive WndProc Calls
'; secure subclassing experiments.
'; by daniel aue, Jan.2004
'
'      .386
'      .model flat, stdcall
'      option casemap :none
'
'
'    .code
'WM_VSCROLL  equ <115h>
'WM_HSCROLL  equ <114h>
'
'main:
'    jmp code
'Working:
'    db  0,0   ;Recursive Call Counters
'OldProc:
'    dd  305419896   ;OldProc is now at asm(1)
'MyProc:
'    dd  305419896   ;MyProc is at asm(2)
'
'code:
'    ;get EIP:
'    Call here
'here:
'
'        ;increase OldProc Call Count:
'        mov     eax,[esp]   ;get local address for ip relative code
'        add     eax, Offset Working- here
'        inc     byte ptr [eax]
'
'
';------------------------------------------------------------
'        ;create identical Stack Parameters for Call to OldProc
'        mov     eax,ebp ;save ebp
'        mov ebp, esp
'        push [ebp+20]
'        push [ebp+16]
'        push [ebp+12]
'        push [ebp+8]
'        mov     ebp,eax ;restore ebp
'
'        ; call OldWinProc:
'        mov     eax,[esp+16]   ;get local address for ip relative code
'        add     eax, Offset OldProc - here
'        mov     eax,dword ptr [eax] ;pOldWinProc
'        call    eax       ;continue Execution at old WinProc
'        push    eax       ;save Return Value
';------------------------------------------------------------
'
'        ;decrease OldProc Call Count:
'        mov     eax,[esp+4]   ;get local address for ip relative code
'        add     eax, Offset Working- here
'        dec     byte ptr[eax]
'
'
'
'
'        ;check for WM_HSCROLL / WM_VSCROLL Message, cause these seem to be produced
'        ;recursively, so allway's let them pass:
'        cmp     dword ptr [esp+16],WM_HSCROLL
'        je      Bypass              ;Bypass OldProc Call Count Check
'        cmp     dword ptr [esp+16],WM_VSCROLL
'        je Bypass
'
'        ;check OldProc Call Count
'        mov     eax,[esp+4]   ;get local address for ip relative code
'        add     eax, Offset Working- here
'        cmp     byte ptr[eax],0
'        jne BusyInOldProc
'
'Bypass:
'        ;check MyProc Call Count
'        cmp     byte ptr[eax+1],0
'        jne BusyInMyProc
'        inc     byte ptr[eax+1]
'
'
';------------------------------------------------------------
'        ;create identical Stack Parameters for Call to MyProc
'        mov     eax,ebp ;save ebp
'        mov ebp, esp
'        push [ebp+20+4]
'        push [ebp+16+4]
'        push [ebp+12+4]
'        push [ebp+8+4]
'        mov     ebp,eax ;restore ebp
'
'        ; call MyWinProc:
'        mov eax,[esp+16+4]   ;get local address for ip relative code
'        add     eax, Offset MyProc - here
'        mov     eax,dword ptr [eax] ;pMyWinProc
'        Call eax
';------------------------------------------------------------
'
'
'        ;decrease MyProc Call Count
'        mov     eax,[esp+4]   ;get local address for ip relative code
'        add     eax, Offset Working- here
'        dec     byte ptr[eax+1]
'
'BusyInMyProc:
'BusyInOldProc:
'
'    pop eax ;get return value from OldProc
'
'
'Return:
'    add     esp,4   ;pop local address
'    ret 16
'end main

